/////
// BIOMORFY-"CONTROL" - riadiace funkcie, vykreslovanie biomorfov
/////

#include "pbio_c.h"


int matherrX=0;     	// premenna pre indikaciu chyby matem. koprocesora

int Xsize=200;		// rozmer obrazka v pixeloch (X-os)
int Ysize=200;          //			     (Y-os)

int Rzoom=10;           // kolkokrat mensi bude vyberovy ramcek oproti celemu obrazku

char pal[17];           // mapovanie farieb palety



unsigned char func[MAXsubfunc+1]={2,1,0};	// pole na reprezentaciu
						// tvaru funkcie


/////
// MATHERR: zachyti chybu matematickeho koprocesora
/////
int matherr (struct exception *a)
{
 a->retval=0;
 matherrX=1;
 return 1;
}

/////
// FN: iteracna funkcia
/////
complex fn(complex &z, complex &u)
{
int i;
complex c(0.,0.), p;
 for(i=0; func[i]!=0; i++)     // ... iteracna funkcia je suctom subfunkcii
 {
  switch(func[i])
  {
   case  1: c+=u; break;
   case  2: c+=z*z; break;
   case  3: c+=z*z*z; break;
   case  4: p=z*z; c+=p*p; break;
   case  5: p=z*z; c+=p*p*z; break;
   case  6: p=z*z*z; c+=p*p; break;
   case  7: c+=pow(z,z); break;
   case  8: c+=exp(z); break;
   case  9: c+=sin(z); break;
  }
 }
 return c;
}

#define Nsubfunc 10		// pocet subfunkcii iteracnej funkcie
char funcS[Nsubfunc][25]={	// tvar subfunkcii iteracnej funkcie
 "",
 "u",
 "z^2",
 "z^3",
 "z^4",
 "z^5",
 "z^6",
 "z^z",
 "exp(z)",
 "sin(z)"};


/////
// VYKRESLI: vykreslenie fraktaloveho obrazka (jadro programu)
/////
void vykresli(Suradnice &a)
{
double step;
complex z;
int color, x, y, k;
 hidemouse();
 step=(a.r1-a.r0)/Xsize;	// step = sirka 1 pixelu v obrazku
 for(y=0; y<Ysize; y++)
 {
  setcolor(0); line(0,y+1,Xsize-1,y+1);
  setcolor(15); line(0,y,Xsize-1,y);
  for(x=0; x<Xsize; x++)
  {
   z=complex(a.r0+x*step,a.i0+(Ysize-y-1)*step);	// - mame bod z komplexnej roviny
   for(k=0; k<a.N; k++)
   {
    z=fn(z,a.u);
    if(abs(z)>a.T) break;	// - zistujeme, ci je ohraniceny, alebo nie
   }
   if (abs(real(z))<a.T || abs(imag(z))<a.T) { color=0; }	// - test konvergencie
   else					// - tu sa rozhoduje, ci bod bude cierny, alebo biely
   {
    if(a.blackNwhite) color=16;
    else color=1+k%15;
   }
   if(matherrX) { matherrX=0; color=16; }
   putpixel(x,y,pal[color]);
  }
  if(kbhit()) return;
 }
}


/////
// EDIT_FUNC: uprava tvaru iteracnej funkcie - vyber podfunkcii
/////
int edit_func()
{					// pole "func" musi byt ukoncene 0
int i, j, mx, my, btns, Nf, redraw;     // rata sa s tym, ze v poli bude
unsigned char s[MAXsubfunc+1];          //  aspon jedna 1 a bude vzdy ako
 strcpy(s,func); 			//  poseldna z retazca
 for(;;)
 {
  hidemouse();
  cleardevice();
  setcolor(3);
  outtextxy(300,210,"PRIDANIE SUBFUNKCIE:");
  outtextxy(300,220," kliknite mysou na prislusnu subfunkciu");
  outtextxy(300,230," vo 'vybere subfunkcii'");
  outtextxy(300,250,"ODOBRATIE SUBFUNKCIE:");
  outtextxy(300,260," kliknite mysou na prislusnu subfunkciu");
  outtextxy(300,270," v 'aktualnej funkcii'");

  setcolor(3);
  outtextxy(0,210,"NAVRAT:");
  setcolor(11);
  outtextxy(0,230," Enter - prijat zmeny");
  outtextxy(0,240,"   Esc - zrusit zmeny");
  setcolor(3);
  outtextxy(0, 20,"AKTUALNA FUNKCIA:");
  setcolor(7);
  outtextxy(0, 40," f(z)");

  for(i=0,Nf=0; s[i]!=0; i++,Nf++)
  {
   if(s[i]!=1) setcolor(15);
   else setcolor(7);
   if(i) outtextxy(16,50+i*10,"+");
   else outtextxy(16,50+i*10,"=");
   outtextxy(32,50+i*10,funcS[s[i]]);
  }

  setcolor(3);
  outtextxy(300, 20,"VYBER SUBFUNKCII:");
  setcolor(15);
  for(i=2; i<Nsubfunc; i++) outtextxy(308,20+i*10,funcS[i]);

  redraw=0;
  showmouse();
  while(btns) mousestate(btns,mx,my);
  do
  {
   mousestate(btns,mx,my);
   if(btns==1)
   {
    hidemouse();
    while(btns) mousestate(btns,mx,my);
    redraw=1;
    j=my/10;
    if(mx<300)
    {
     j-=5;
     if(j>=0 && j<Nf-1)
     {
      for(i=j+1; i<Nf; i++) s[i-1]=s[i];
      s[Nf-1]=0;
     }
     else
     {
      redraw=0;
      showmouse();
     }
    }
    else
    {
     j-=2;
     if(j>=2 && j<Nsubfunc && Nf<MAXsubfunc)
     {
      s[Nf-1]=j;
      s[Nf]=1;
      s[Nf+1]=0;
     }
     else
     {
      redraw=0;
      showmouse();
     }
    }
   }
   if(kbhit())
   {
    hidemouse();
    switch(tolower(getch()))
    {
     case 27: return 1;
     case 13: strcpy(func,s); return 0;
    }
   }
  }
  while(!redraw);
 }
}


/////
// EDIT_DOUBLE: editacia cisla typu "double"
/////
double edit_double(double d, int x, int y)
{
int i, j, l;
char s[60], c;
 setcolor(15);
 sprintf(s,"%lg",d);
 for(l=0; s[l]!=0; l++)
  if(l==31) s[32]=0;
 i=l;
 for(;;)
 {
  setviewport(x-1,y-1,x+262,y+8,0);
  clearviewport();
  setviewport(0,0,getmaxx(),getmaxy(),0);
  outtextxy(x,y,s);
  line(x+i*8-1, y-1, x+i*8-1, y+8);
  switch(c=getch())
  {
   case 27:		// Esc - nechat cislo bezo zmeny
    return d;
   case 13: 		// Enter - akceptovat zmeny
    if(sscanf(s,"%lg",&d)==1)
     return d;
    break;
   case 8:		// BackSpace
    if(i!=0)
    {
     for(j=i--; j<=l; j++) s[j-1]=s[j];
     l--;
    }
    break;
    case 0:
     switch(getch())
     {
      case 'S': 	// Delete
       if(i!=l)
       {
	for(j=i+1; j<=l; j++) s[j-1]=s[j];
	l--;
       }
       break;
      case 'G':		// Home
       i=0;
       break;
      case 'O':		// End
       i=l;
       break;
      case 'K':		// sipka vlavo
       if(i>0) i--;
       break;
      case 'M':		// sipka vpravo
       if(i<l) i++;
       break;
     }
     break;
    default:		// cislice, bodka, minus, exponent
     if((c=='.' || tolower(c)=='e' || c=='-' || (c>='0' && c<='9')) && l<32)
     {
      for(j=++l; j>i; j--) s[j]=s[j-1];
      s[i++]=c;
     }
  }
 }
}


/////
// ULOZ_OBR: ulozenie obrazka do suboru
/////
void uloz_obr(Suradnice &a, Suradnice &last)
{
int zoom=(int)floor((last.r1-last.r0)/(a.r1-a.r0)+.5);
 hidemouse();
 if(uloz_bmp(a,zoom)<0)     // ulozi obrazok aj so zakladnymi informaciami ako bitmapu
 {
  cleardevice();
  setcolor(12);
  outtextxy(100,100,"CHYBA PRI ZAPISE DO SUBORU !!!");
  setcolor(11);
  outtextxy(300,160,"stlac Enter pre pokracovanie");
  while(getch()!=13);
 }
 cleardevice();
}


/////
// INIC_PREM: inicializacia "suradnic"
/////
void inic_prem(Suradnice &a)
{
int i;
 a.u=complex(-.5,0.);
 a.N=10;
 a.T=4.;
 a.r0=-10.;
 a.r1=10.;
 a.i0=-10.;
 a.blackNwhite=1;
}


/////
// INIC_PAL: nastavenie standardnej palety
/////
void inic_pal()
{
int i;
 for(i=0; i<16; i++)  pal[i]=i;
 pal[16]=15;
}


void kresli_sipku(int c, int y1, int y2)
{
int i;
char s[5];
 setcolor(c);
 if(y2==y1 || y2==y1-1)
 {
  sprintf(s,"%c",16);
  outtextxy(105,y1*16+130,s);
 }
 if(y2<y1-1)
 {
  outtextxy(105,y1*16+130,"ͼ");
  for(i=y1-1; i>y2; i--)
  {
   outtextxy(105,i*16+130,"  ");
   outtextxy(105,i*16+130+8,"  ");
  }
  sprintf(s,"%cͻ",17);
  outtextxy(105,y2*16+130+8,s);
 }
 if(y2>y1)
 {
  outtextxy(105,y1*16+130,"ͻ");
  for(i=y1+1; i<y2+1; i++)
  {
   outtextxy(105,i*16+130-8,"  ");
   outtextxy(105,i*16+130,"  ");
  }
  sprintf(s,"%cͼ",17);
  outtextxy(105,y2*16+130+8,s);
 }
}


/////
// NASTAVENIE_PAL: nastavenie palety farieb
/////
void nastavenie_pal()
{
int i, draw=0, btns, mx, my, y1, y11, y2, y22;
char s[80], c, p;
 cleardevice();
 setcolor(3);
 outtextxy(190,40,"USPORIADANIE FARIEB PALETY");
 outtextxy(300,150,"<  mysou najprv vyberte farbu, ktoru");
 outtextxy(300,160,"    chcete presunut, potom ju tahom");
 outtextxy(300,170,"    presunte na nove miesto");
 setcolor(11);
 outtextxy(333,240,"S - standardne usporiadanie palety");
 outtextxy(333,260,"Esc/Enter - navrat");
 setcolor(7);
 outtextxy(10, 80,"I - pocet iteracii, po ktorych");
 outtextxy(10, 90,"    sa bod ukaze ako neohraniceny");
 outtextxy(10,100,"    a priradi sa mu dana farba");
 outtextxy(10,110,"    (pri vacsom pocte iteracii");
 outtextxy(10,120,"     sa farby cyklicky opakuju)");
 do
 {
  for(i=1; i<16; i++)
  {
   setcolor(pal[i]);
   setfillstyle(SOLID_FILL,pal[i]);
   bar(58,i*16+127,98,i*16+137);
   setcolor(15);
   sprintf(s,"%2d",i);
   outtextxy(36,i*16+130,s);
  }
  outtextxy(10,146,"I =");
  do{ mousestate(btns,mx,my); }while(btns!=0);
  do
  {
   mousestate(btns,mx,my);
   y1=(my+3)/16-8;
   y2=(my-5)/16-8;
   switch(draw)
   {
    case 0:
     showmouse();
     draw=1;
     break;
    case 1:
     if(btns==1 && mx<200 && y1>=1 && y1<=15)
     {
      hidemouse();
      kresli_sipku(15,y1,y2);
      y11=y1;
      y22=y2;
      draw=2;
     }
     break;
    case 2:
     if(y2<0) y2=0;
     if(y2>15) y2=15;
     if(y2!=y22 || btns==0)
     {
      kresli_sipku(0,y11,y22);
      kresli_sipku(15,y11,y22=y2);
      if(btns==0)
      {
       kresli_sipku(0,y11,y22);
       draw=0;
       p=pal[y11];
       if(y11>y22+1)
       {
	for(i=y11-1; i>y22; i--)
	 pal[i+1]=pal[i];
	pal[y22+1]=p;
       }
       if(y11<y22)
       {
	for(i=y11; i<y22; i++)
	 pal[i]=pal[i+1];
	pal[y22]=p;
       }
      }
     }
     break;
   }
   if (kbhit())
   {
    switch(tolower(c=getch()))
    {
     case 0:
      getch();
      break;
     case 27:
     case 13:
      if(draw==1)  draw=0;
      break;
     case 's':
      if(draw==1)
      {
       inic_pal();
       draw=0;
      }
      break;
    }
   }
  }
  while(draw);
  hidemouse();
 }
 while(c!=13 && c!=27);
}


/////
// NASTAVENIA: nastavenie "suradnic" a ostatnych parametrov
/////
int nastavenia(Suradnice sur[], Suradnice &a)
{
int redraw, btns, mx, my, pom;
char s[80];
double i1, step;
 hidemouse();
 for(;;)
 {
  step=(a.r1-a.r0)/Xsize;	// step = sirka 1 pixelu v obrazku
  i1=a.i0+Ysize*step;           // horna hranica na imaginarnej osi
  cleardevice();		//  - vypocita sa tak, aby obrazok nebol zdeformovany
  setcolor(10);
  outtextxy(200,0,"PICKOVEROVE BIOMORFY");

  setcolor(3);
  outtextxy(400, 30,"NAPOVEDA PRE OBRAZOK:");
  outtextxy(400, 40," pomocou mysi oznacte");
  outtextxy(400, 50,"  vyrez v obrazku:");
  outtextxy(400, 60,"  (lave tl. - umiestnenie)");
  outtextxy(400, 70,"  (prave tl. - velkost vyrezu)");
  outtextxy(400, 80," po stlaceni klavesu Enter");
  outtextxy(400, 90,"  sa zobrazi dany vyrez");
  outtextxy(400,100,"  komplexnej roviny");
  outtextxy(400,120,"HOTKEYS V OBRAZKU:");
  outtextxy(400,130,"    Esc: tato obrazovka");
  outtextxy(400,140,"  Enter: zobrazenie vyrezu");
  outtextxy(400,150," BckSpc: krok spat");
  outtextxy(400,160,"     + : N=N+1");
  outtextxy(400,170,"     * : N=N+5");
  outtextxy(400,180,"     - : N=N-1");
  outtextxy(400,190,"     / : N=N-5");
  outtextxy(400,200,"   Home: 'zoom out'");
  outtextxy(400,210,"    Spc: ulozenie obrazku");

  outtextxy(320,260,"<  kliknutim mysou na polozky vlavo");
  outtextxy(320,270,"<  mozete menit ich hodnoty");
  outtextxy(320,280,"      (okrem 'i1' - vypocitava sa)");

  setcolor(11);
  outtextxy(400,360,"BckSpc: krok spat");
  outtextxy(400,370," Enter: obrazok");
  outtextxy(400,380,"    R : 'reset' premennych");
  outtextxy(400,390,"    Q : opustenie programu");

  setcolor(3);
  outtextxy(0, 30,"VYZNAM PREMENNYCH:");
  outtextxy(0, 40," r0 - dolna hranica na realnej osi");
  outtextxy(0, 50," r1 - horna hranica na realnej osi");
  outtextxy(0, 60," i0 - dolna hranica na realnej osi");
  outtextxy(0, 70," i1 - horna hranica na realnej osi");
  outtextxy(0, 80," u  - komplexna konstanta");
  outtextxy(0, 90," T  - prahova hodnota (urcenie divergencie bodu)");
  outtextxy(0,100," N  - maximalny pocet iteracii (pre 1 bod)");

  setcolor(15);
  sprintf(s,"   r0 = %lg",a.r0);      outtextxy(0,160,s);
  sprintf(s,"   r1 = %lg",a.r1);      outtextxy(0,170,s);
  sprintf(s,"   i0 = %lg",a.i0);      outtextxy(0,180,s);
  setcolor(7);
  sprintf(s,"   i1 = %lg",i1);        outtextxy(0,190,s);
  setcolor(15);
  sprintf(s,"Re{u} = %lg",real(a.u)); outtextxy(0,200,s);
  sprintf(s,"Im{u} = %lg",imag(a.u)); outtextxy(0,210,s);
  sprintf(s,"    T = %lg",a.T);       outtextxy(0,220,s);
  sprintf(s,"    N = %d",a.N);        outtextxy(0,230,s);
  if(a.blackNwhite)
   outtextxy(0,250,"Obraz: cierno/biely");
  else
   outtextxy(0,250,"Obraz: 16 farieb");
  outtextxy(0,260,"Nastavenie palety farieb ...");
  sprintf(s,"Sirka obrazu: %d",Xsize);   outtextxy(0,280,s);
  sprintf(s,"Vyska obrazu: %d",Ysize);   outtextxy(0,290,s);
  sprintf(s,"Zmensenie vyrezu oproti obrazku: %dx",Rzoom); outtextxy(0,300,s);
  strcpy(s,"FUNKCIA: ");
  for(pom=0; func[pom]!=0; pom++)
  {
   if(pom) strcat(s," + ");
   strcat(s,funcS[func[pom]]);
  }
  outtextxy(0,330,s);
  sprintf(s,"Nastavenie adresara pre obrazky ..."); outtextxy(0,370,s);

  redraw=0;
  showmouse();
  do
  {
   mousestate(btns,mx,my);
   if(btns==1 && mx<300)
   {
    hidemouse();
    redraw=1;
    switch((my+1)/10)
    {
     case 16:
      a.r0=edit_double(a.r0,64,160);
      break;
     case 17:
      a.r1=edit_double(a.r1,64,170);
      break;
     case 18:
      a.i0=edit_double(a.i0,64,180);
      break;
     case 20:
      a.u=complex(edit_double(real(a.u),64,200),imag(a.u));
      break;
     case 21:
      a.u=complex(real(a.u),edit_double(imag(a.u),64,210));
      break;
     case 22:
      a.T=edit_double(a.T,64,220);
      break;
     case 23:
      if((pom=(int)edit_double(a.N,64,230))>0) a.N=pom;
      break;
     case 25:
      a.blackNwhite=!a.blackNwhite;
      while(btns) mousestate(btns,mx,my);
      break;
     case 26:
      nastavenie_pal();
      break;
     case 28:
      pom=(int)edit_double(Xsize,112,280);
      if(pom>1 && pom<=getmaxx()+1) Xsize=pom;
      break;
     case 29:
      pom=(int)edit_double(Ysize,112,290);
      if(pom>1 && pom<=getmaxy()+1) Ysize=pom;
      break;
     case 30:
      pom=(int)edit_double(Rzoom,264,300);
      if(pom>0 && pom<2*getmaxx()) Rzoom=pom;
      break;
     case 33:
      if (edit_func()==0) inic_prem(a);
      break;
     case 37:
      nastavenie_adr();
      break;
     default:
      redraw=0;
      showmouse();
    }
   }
   if(kbhit())
   {
    hidemouse();
    switch(tolower(getch()))
    {
     case 'q': return 0;			 // klaves Q - opustenie programu
     case 'r': inic_prem(a); break;		 // klaves R - reset premennych
     case 13: cleardevice(); return 2;		 // ENTER - vykreslenie obrazka
     case 8: sur_posun(sur,-1); a=sur[0]; break; // BCKSPC - obnovenie suradnic z predch. kroku
    }
    redraw=1;
   }
  }
  while(!redraw);
 }
}


/////
// XORRECTANGLE: vykreslenie obdlznika metodou XOR_PUT
/////
void xorrectangle(int x1, int y1, int x2, int y2)
{
int i;
 for(i=x1; i<=x2; i++)
 {
  putpixel(i,y1,getpixel(i,y1)^0xffff);
  putpixel(i,y2,getpixel(i,y2)^0xffff);
 }
 for(i=y1; i<=y2; i++)
 {
  putpixel(x1,i,getpixel(x1,i)^0xffff);
  putpixel(x2,i,getpixel(x2,i)^0xffff);
 }
}


/////
// OVLADANIE_V_OBRAZKU: obsluhuje oznacenie vyrezu mysou a "hot-keys" v obrazku
/////
int ovladanie_v_obrazku(Suradnice sur[], Suradnice &a)
{
Suradnice aa;
int btns, Rx1, Rx, Rx_, Ry1, Ry, mx, my, state=9;
double pom, step;
long z;

 step=(a.r1-a.r0)/Xsize;
 aa=a;
 Rx1=-1; Rx=(int)floor(Xsize/Rzoom+.5);
 Ry=(int)(((long)Rx)*Ysize/Xsize);
 showmouse();				// premenna "state":
 do                                     //  9 - vidno kurzor mysi, je mozne zacat oznacovat vyrez
 {					//  7 - kurzor mysi nevidno, urcuje sa poloha vyrezu (ramceka)
  mousestate(btns,mx,my);		//  6 - kurzor mysi nevidno, urcuje sa velkost vyrezu
  if(state==9 && btns==1)
  {
   state=7;  hidemouse();
   if(Rx1>=0) xorrectangle(Rx1,Ry1,Rx1+Rx,Ry1+Ry);
   Rx1=mx;  Ry1=my;
  }
  if(state==9 && btns==2)
  {
   state=6;  hidemouse();
   if(Rx1>=0) xorrectangle(Rx1,Ry1,Rx1+Rx,Ry1+Ry);
   else { Rx1=mx; Ry1=my; }
   Rx_=mx-Rx;
  }
  if(state==6)
  {
   Rx=mx-Rx_;
   if(Rx1+Rx>Xsize) Rx=Xsize-Rx1;
   Ry=(int)(((long)Rx)*Ysize/Xsize);
   if(Ry1+Ry>Ysize) Ry=Ysize-Ry1;
   Rx=(int)(((long)Ry)*Xsize/Ysize);
   if(Rx<1) Rx=1;
   if(Ry<1) Ry=1;
  }
  if(state==7)
  {
   Rx1=mx; if(Rx1+Rx>Xsize) Rx1=Xsize-Rx;
   Ry1=my; if(Ry1+Ry>Ysize) Ry1=Ysize-Ry;
  }
  if(state==6 || state==7) xorrectangle(Rx1,Ry1,Rx1+Rx,Ry1+Ry);
  if((state==6 || state==7) && btns==0)
  {
   a.r0=aa.r0+Rx1*step;  a.r1=a.r0+Rx*step;  a.i0=aa.i0+(Ysize-Ry-Ry1)*step;
   state=9;  showmouse();
  }
  if(kbhit())
  {
   switch(getch())
   {
    case 13: state=3; break;		// ENTER - vykreslenie obrazku (so zmenenymi parametrami)
    case 27: state=2; break;		// Esc - navrat do obrazkovky nastaveni
    case '*': a.N+=5; state=3; break;	// }
    case '/': a.N-=5; state=3; break;   // }  - zmena max. poctu iteracii
    case '+': a.N++; state=3; break;    // }
    case '-': a.N--; state=3; break;    // }
    case 8: sur_posun(sur,-1); a=sur[0]; state=3; break; // BCKSPC - obnovenie suradnic z predch. kroku
    case ' ': uloz_obr(aa,sur[1]); state=3; break;       // SPACE - ulozenie obrazku
    case 0:
     switch(getch())
     {
      case 'G':					// HOME - "zoom-out"
      pom=a.r1-a.r0;  a.r0-=pom*2;  a.r1+=pom*2;
      pom=Ysize*step;  a.i0-=pom*2;
      state=3;
      break;
     }
     break;
   }
  }
  if(state==6 || state==7) xorrectangle(Rx1,Ry1,Rx1+Rx,Ry1+Ry);
 }
 while(state>3);
 return state;
}


/////
// BIOMORF: hlavna procedura programu
/////
void biomorf()
{
Suradnice sur[SurStackSize], a;	// "sur" sluzi ako zasobnik na odpamatavanie starsich hodnot "suradnic"
int state=10;			// v "a" su aktualne "suradnice"

 initmouse();
 inic_pal();
 inic_prem(a);
 sur[0]=a;
 sur_posun(sur,SurStackSize-1);
 do
 {
  do
  {
   if(state==10) break;		// po prvykrat sa najprv prepne program na obrazovku nastaveni
   vykresli(a);
   if(!equal(a,sur[0]))		// ak boli suradnice oproti predchadzajucemu kroku zmenene, ulozia sa do zasobnika
   {
    sur_posun(sur,1);
    sur[0]=a;
   }
   state=ovladanie_v_obrazku(sur, a);
  }
  while(state>2);
  state=nastavenia(sur,a);
 }
 while(state>0);
 hidemouse();
}
