/////
// ukladanie do bitmapoveho suboru
/////


#include "pbio_sub.h"



char sub[80]="bm00.bmp";	// defaultovy nazov suboru
int obr_info[5]={0,0,0,0,0};	// oznacuje, ktore informacie sa maju s obrazkom ulozit

char buf[BSize];	// buffer



/////
// SAVE_SCREEN4: ulozi vyrez obrazovky od laveho horneho rohu po bod [x,y] do suboru
/////
int save_screen4(char *fnm, long x, long y)	// ("4" = 4-bitova farba)
{		// tvar suboru: 4B - sirka, 4B - vyska, potom obrazok (po polBytoch)
FILE *f;
int i, j, k, a, b, x2;
 if(odd(x)) x++;	// kvoli jednoduchosti sa pozaduje, aby vyska aj sirka boli parne cisla
 if(odd(y)) y++;
 x2=x/2;
 if((f=fopen(fnm,"wb"))==NULL) return -1;
 if(fwrite(&x, sizeof(long), 1, f)!=1) return -1;
 if(fwrite(&y, sizeof(long), 1, f)!=1) return -1;
 for(j=y-1; j>=0; j--)
 {
  for(i=0,k=0; i<x; i+=2,k++)
  {
   a=getpixel(i,j);
   b=getpixel(i+1,j);
   a<<=4;
   a|=b;
   buf[k]=a;
  }
  if(fwrite(&buf, x2, 1, f)!=1) return -1;
 }
 if(fclose(f)!=0) return -1;
 return 0;
}


/////
// CREATE_BMP4: vytvori hlavicku BMP-suboru pre obrazok s rozmermi "x", "y"
/////
int create_bmp4(char *fnm, long x, long y)
{
FILE *f;
BMP_FILE_HEADER fh;
BMP_INFO_HEADER ih;
TRGBQuad pal[]={		// paleta
 {0x00, 0x00, 0x00, 0x00},
 {0xb0, 0x00, 0x00, 0x00},
 {0x00, 0xb0, 0x00, 0x00},
 {0xb0, 0xb0, 0x00, 0x00},
 {0x00, 0x00, 0xb0, 0x00},
 {0xb0, 0x00, 0xb0, 0x00},
 {0x00, 0xb0, 0xb0, 0x00},
 {0xb0, 0xb0, 0xb0, 0x00},
 {0x70, 0x70, 0x70, 0x00},
 {0xff, 0x00, 0x00, 0x00},
 {0x00, 0xff, 0x00, 0x00},
 {0xff, 0xff, 0x00, 0x00},
 {0x00, 0x00, 0xff, 0x00},
 {0xff, 0x00, 0xff, 0x00},
 {0x00, 0xff, 0xff, 0x00},
 {0xff, 0xff, 0xff, 0x00}};
long img_size;
 if(odd(x)) x++;
 if(odd(y)) y++;
 img_size=x*y/2;
 if((f=fopen(fnm,"wb"))==NULL) return -1;
 fh.password1='B';
 fh.password2='M';
 fh.file_size=118L+img_size;
 fh.reserved1=0;
 fh.reserved2=0;
 fh.OffsetBytes=118L;
 if(fwrite(&fh, sizeof(BMP_FILE_HEADER), 1, f)!=1) return -1;
 ih.biSize=40L;	    /* Urcuje velkost BMP_INFO_HEADRA           */
 ih.sirka=x;
 ih.vyska=y;
 ih.planes=1;
 ih.BitCount=4;	    /* Pocet bitov na farbu pixelu */
 ih.compresion=0L;    /* typ kompresie                            */
 ih.imageSize=img_size;	    /* Velkost obrazka v bytoch                 */
 ih.X_Resolution=3790L;  /* Rozlisenie na X-osi       */
 ih.Y_Resolution=3780L;  /* Rozlisenie na Y-osi       */
 ih.ColorsUsed=0L;	    /* Pole pouzitych farieb, ak 0 -> vsetky    */
 ih.ColImportant=0L;  /* Pole zakladnych farieb pre dany obrazok  */
 if(fwrite(&ih, sizeof(BMP_INFO_HEADER), 1, f)!=1) return -1;
 if(fwrite(&pal, sizeof(TRGBQuad), 16, f)!=16) return -1;
 if(fclose(f)!=0) return -1;
 return 0;
}


/////
// APPEND_BMP4: k suboru "bmp" (bitmap) prida subor "scr" (ulozeny pomocou "save_screen4")
/////
int append_bmp4(char *bmp, char *scr)	// ("bmp" musi mat velkost obrazka nastavenu
{					//  tak, aby bol po pridani "scr" korektny)
FILE *f, *g;
BMP_FILE_HEADER fh;
BMP_INFO_HEADER ih;
long x, y;
int xs2, xb2, i;
 for(i=0; i<BSize; i++) buf[i]=0;
 if((f=fopen(bmp,"rb"))==NULL) return -1;
 if(fread(&fh, sizeof(BMP_FILE_HEADER), 1, f)!=1) return -1;
 if(fread(&ih, sizeof(BMP_INFO_HEADER), 1, f)!=1) return -1;
 fclose(f);
 xb2=ih.sirka/2;
 if(xb2%4!=0) xb2+=4-xb2%4;
 if((f=fopen(bmp,"ab"))==NULL) return -1;
 if((g=fopen(scr,"rb"))==NULL) return -1;
 if(fread(&x, sizeof(long), 1, g)!=1) return -1;
 if(fread(&y, sizeof(long), 1, g)!=1) return -1;
 xs2=x/2;
 for(i=0; i<y; i++)
 {
  if(fread(&buf, xs2, 1, g)!=1) return -1;
  if(fwrite(&buf, xb2, 1, f)!=1) return -1;
 }
 fclose(g);
 if(fclose(f)!=0) return -1;
 remove(scr);
 return 0;
}


/////
// EDIT_SUB: editacia mena suboru (s 3-pismenovou priponou, ktora sa neda menit)
/////
int edit_sub(int x, int y)
{
int i, j, l;
char s[80], c;
 setcolor(15);
 strcpy(s,sub);
 l=strlen(s);
 i=l-4;
 for(;;)
 {
  setviewport(x-1,y-1,x+262,y+8,0);
  clearviewport();
  setviewport(0,0,getmaxx(),getmaxy(),0);
  outtextxy(x,y,s);
  line(x+i*8-1, y-1, x+i*8-1, y+8);
  switch(c=getch())
  {
   case 27:		// Esc - nechat bezo zmeny
    return 1;
   case 13:             // Enter - akceptovat zmeny v nazve suboru
    strcpy(sub,s);
    return 0;
   case 8:		// BackSpace
    if(i!=0)
    {
     for(j=i--; j<=l; j++) s[j-1]=s[j];
     l--;
    }
    break;
    case 0:
     switch(getch())
     {
      case 'S':		// Delete
       if(i!=l)
       {
	for(j=i+1; j<=l; j++) s[j-1]=s[j];
	l--;
       }
       break;
      case 'G':		// Home
       i=0;
       break;
      case 'O':		// End
       i=l-4;
       break;
      case 'K': 	// sipka vlavo
       if(i>0) i--;
       break;
      case 'M':		// sipka vpravo
       if(i<l-4) i++;
       break;
     }
     break;
    default:
     if(l<79)		// ostatne pismena
     {
      for(j=++l; j>i; j--) s[j]=s[j-1];
      s[i++]=c;
     }
  }
 }
}


/////
// DIR_EXISTS: zisti, ci dane meno adresara je platne a adresar existuje
/////
int dir_exists(char *d)
{
char s[81], r;
 if(d[0]==0) return 1;
 getcwd(s,80);
 r=chdir(d);
 chdir(s);
 return !r;
}


/////
// ROZDEL_CESTU: rozdelenie uplnej cesty na adresar a meno suboru
/////
void rozdel_cestu(char *sub, char *dir, char *fnm)
{
int i, j;
 i=-1;
 for(j=0; sub[j]!=0; j++) if(sub[j]=='\\') i=j;
 if(dir!=NULL)
 {
  for(j=0; j<=i; j++) dir[j]=sub[j];
  dir[j]=0;
 }
 if(fnm!=NULL)
 {
  for(j=0,i++; sub[i]!=0; i++,j++) fnm[j]=sub[i];
  fnm[j]=0;
 }
}


/////
// UDAJE_OBR: vykreslenie zelanych udajov o biomorfe
/////
void udaje_obr(Suradnice &a, int zoom, int &i, int &j)
{
int pom;
char s[80];
 i=2; j=0;
 setcolor(15);
 if(obr_info[0])		// vykreslenie pozadovanych udajov
 {
  sprintf(s,"Re: %lg .. %lg",a.r0,a.r1);
  outtextxy(0,i,s);
  if(strlen(s)>j) j=strlen(s);
  i+=10;
  sprintf(s,"Im: %lg .. %lg",a.r0,a.r1);
  outtextxy(0,i,s);
  if(strlen(s)>j) j=strlen(s);
  i+=10;
 }
 if(obr_info[1])
 {
  sprintf(s,"T = %lg;   N= %d",a.T,a.N);
  outtextxy(0,i,s);
  if(strlen(s)>j) j=strlen(s);
  i+=10;
 }
 if(obr_info[2])
 {
  sprintf(s,"u = %lg + %lg*i",real(a.u),imag(a.u));
  outtextxy(0,i,s);
  if(strlen(s)>j) j=strlen(s);
  i+=10;
 }
 if(obr_info[3])
 {
  strcpy(s,"f(z) = ");
  for(pom=0; func[pom]!=0; pom++)
  {
   if(pom) strcat(s," + ");
   strcat(s,funcS[func[pom]]);
  }
  outtextxy(0,i,s);
  if(strlen(s)>j) j=strlen(s);
  i+=10;
 }
 if(obr_info[4])
 {
  sprintf(s,"zoomed in: %dx",zoom);
  outtextxy(0,i,s);
  if(strlen(s)>j) j=strlen(s);
  i+=10;
 }
 j*=8;
 if(i>2) i+=2;
}


/////
// NASTAVENIA_SUB: nastavi sa adresar a nazov suboru a vyberu sa udaje, ktore sa s obrazkom ulozia do suboru
/////
int nastavenia_sub(Suradnice &a, int zoom)
{
int redraw, mx, my, btns, i, j, done;
char s[110], dir[80], ss[80];
struct ffblk f;

 hidemouse();
 for(;;)
 {
  rozdel_cestu(sub,dir,NULL);
  cleardevice();
  setcolor(3);
  outtextxy(170, 30,"NASTAVENIA PRE UKLADANIE DO SUBORU");
  outtextxy(260,100,"< vyber mena suboru a udajov,");
  outtextxy(260,110,"  ktore sa maju vlozit do obrazku");
  outtextxy(260,120,"  urobite kliknutim mysou na prislusnu plozku");

  setcolor(11);
  outtextxy(450, 70,"Esc - storno");
  outtextxy(450, 80,"ENTER - ulozenie");
   sprintf(s,"Subor (s cestou): %s",sub);
  setcolor(15);
  outtextxy(  0, 60,s);

  setcolor(3);
  outtextxy(  0,110,"DO OBRAZKU VLOZIT:");
  setcolor(15);
  outtextxy( 30,140,"suradnice");
  outtextxy( 30,150,"prah a pocet cyklov");
  outtextxy( 30,160,"konstantu u");
  outtextxy( 30,170,"tvar funkcie");
  outtextxy( 30,180,"zvacsenie od predch. obr.");
  setcolor(14);
  for(i=0; i<5; i++)
   if(obr_info[i]) outtextxy(10,140+i*10,"*");
  setcolor(7);
  rectangle(257,139,getmaxx(),202);
  setviewport(260,140,getmaxx()-1,201,0);
  udaje_obr(a,zoom,i,j);
  setviewport(0,0,getmaxx(),getmaxy(),0);

  setcolor(7);
  line(0,215,getmaxx(),215);
  sprintf(s,"ADRESAR %s*.bmp:",dir);
  outtextxy(0,220,s);
  i=240; j=8;                  	// vypis obsahu adresara, do ktoreho sa BMP-subor zapise
  sprintf(ss,"%s*.bmp",dir);
  done = findfirst(ss,&f,0);
  while (!done)
  {
   sprintf(s,"%12s",f.ff_name);
   outtextxy(j,i,s);
   if((i+=10)>getmaxy()-9) { i=240; j+=112; }
   done = findnext(&f);
  }

  redraw=0;
  showmouse();
  do
  {
   mousestate(btns,mx,my);
   if(btns==1 && mx<250)
   {
    hidemouse();
    while(btns) mousestate(btns,mx,my);
    redraw=1;
    switch((my+1)/10)
    {
     case 6:
      setviewport(450,70,getmaxx(),89,0);
      clearviewport();                    // zmazanie napisu 'Esc...' a 'ENTER...'
      setviewport(0,0,getmaxx(),getmaxy(),0);
      edit_sub(144,60);
      break;
     case 14:
      obr_info[0]=!obr_info[0];
      break;
     case 15:
      obr_info[1]=!obr_info[1];
      break;
     case 16:
      obr_info[2]=!obr_info[2];
      break;
     case 17:
      obr_info[3]=!obr_info[3];
      break;
     case 18:
      obr_info[4]=!obr_info[4];
      break;
     default:
      redraw=0;
      showmouse();
    }
   }
   if(kbhit())
   {
    hidemouse();
    switch(tolower(getch()))
    {
     case 13: return 0;          // Enter
     case 27: return 1;          // Esc
    }
    redraw=1;
   }
  }
  while(!redraw);
 }
}


/////
// ULOZ_BMP: zabezpeci ulozenie obrazku a vybranych udajov do suboru
/////
int uloz_bmp(Suradnice &a, int zoom)
{
int i, j;
char dir[80], s0[80], s1[80], s2[80], s[80], ss[80], c;
struct ffblk f;

 rozdel_cestu(sub,dir,NULL);
 sprintf(s0,"%stemp.0",dir);	// }
 sprintf(s1,"%stemp.1",dir);    // } - mena pomocnych suborov
 sprintf(s2,"%stemp.2",dir);    // }

 if(save_screen4(s1,Xsize,Ysize)) return -1;	// ulozenie obrazka biomorfu do pomocneho suboru

 do
 {
  c=0;
  if(nastavenia_sub(a,zoom))
  {
   remove(s1);      // po stlaceni Esc sa pom. subor "s1" zmaze, obrazok ostane neulozeny
   return 1;
  }
  if(findfirst(sub,&f,0)==0)	// po stlaceni Enter-u sa zisti, ci dany subor uz neexistuje
  {
   setcolor(12);
   outtextxy(0,74,"TAKY SUBOR UZ EXISTUJE, PREPISAT? (a/n)");
   do c=tolower(getch()); while(c!='a' && c!='n');
   if(c=='a')
   {
    if(remove(sub)) return -1;
   }
  }
 }
 while(c=='n');

 cleardevice();
 udaje_obr(a,zoom,i,j);
		// kedze su teraz zname rozmery obrazka aj rozmery udajov (i,j), moze sa vytvorit hlavicka BMP-suboru
 if( create_bmp4(s0, (Xsize>j)?Xsize:j, Ysize+i) ) return -1;
 if(i>2)
 {
  if(save_screen4(s2,j,i)) return -1;	// ulozenie vykreslenych udajov
  cleardevice();
  if(append_bmp4(s0,s2)) return -1;	// pridanie k BMP-hlavicke
 }
 if(append_bmp4(s0,s1)) return -1;	// pridanie obrazka do BMP-suboru
	// teraz su pomocne subory "s1" a "s2" zmazane, ostal "s0", kde je cely BMP-subor

 if(rename(s0,sub)) return -1;	// premenovanie pom. sub. "s0" na zadane meno
 return 0;
}


/////
// NASTAVENIE_ADR: nastavenie adresara pre ukladanie obrazkov
/////
void nastavenie_adr()
{
char dir[80], s[80], old[80], c;
int i;
struct ffblk f;
 strcpy(old,sub);
 for(;;)
 {
  cleardevice();
  setcolor(3);
  outtextxy(170, 50,"NASTAVENIE ADRESARA PRE UKLADANIE OBRAZKOV");
  setcolor(7);
  outtextxy(0, 80,"Adresar s prototypom mena suboru:");
  if(edit_sub(20,100))
  {
   strcpy(sub,old);
   return;
  }

  rozdel_cestu(sub,dir,NULL);
  if(dir_exists(dir)) return;

  setcolor(11);
   sprintf(s,"ADRESAR '%s' NEEXISTUJE",dir);
  outtextxy(10,130,s);
  outtextxy(10,150,"V - vytvorit,   O - opravit zadany nazov");
  do c=tolower(getch()); while(c!='v' && c!='o');
  if(c=='v')
  {
   c=1;
   for(i=0; dir[i]!=0; i++)
   {
    if(dir[i]=='\\')
    {
     dir[i]=0;
     if(!dir_exists(dir))
     {
      if(mkdir(dir))
      {
       setcolor(12);
       outtextxy(30,210,"CHYBA PRI VYTVARANI ADRESARA");
       setcolor(11);
       outtextxy(70,230,"stlac Enter pre pokracovanie");
       while(getch()!=13);
       c=0;
       break;
      }
     }
     dir[i]='\\';
    }
   }
   if(c) return;
  }
 }
}
